﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using System.Data.OleDb;

namespace howto_access_get_autonumber
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        // The connection object.
        private OleDbConnection Conn;

        // Make the database connection.
        private void Form1_Load(object sender, EventArgs e)
        {
            // Make the connection object.
            const string db_name = "Students.mdb";
            Conn = new OleDbConnection(
                "Provider=Microsoft.ACE.OLEDB.12.0;" +
                "Data Source=" + db_name + ";" +
                "Mode=Share Deny None");
        }

        // Create a new Students record.
        private void btnCreate_Click(object sender, EventArgs e)
        {
            // Create the command.
            OleDbCommand cmd = new OleDbCommand(
                "INSERT INTO Students(FirstName, LastName) VALUES (?, ?)",
                Conn);
            cmd.Parameters.Add(new OleDbParameter("FirstName", txtFirstName.Text));
            cmd.Parameters.Add(new OleDbParameter("LastName", txtLastName.Text));

            // Execute the command.
            Conn.Open();
            cmd.ExecuteNonQuery();

            // Get the auto-number value.
            cmd = new OleDbCommand("SELECT @@IDENTITY", Conn);
            OleDbDataReader reader = cmd.ExecuteReader();

            // Read the value.
            if (!reader.Read())
            {
                MessageBox.Show("Error reading the auto-number value");
            }
            else
            {
                // Display the StudentID and other values.
                txtFirstNameResult.Text = txtFirstName.Text;
                txtLastNameResult.Text = txtLastName.Text;
                txtStudentId.Text = reader.GetValue(0).ToString();

                // Clear the input fields.
                txtFirstName.Clear();
                txtLastName.Clear();
            }

            // Close the connection.
            cmd.Dispose();
            Conn.Close();
        }
    }
}
